/*
 File: wysuwyg_dragboard.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwyg_dragdrop.xul
 Description: A window with DND capabilities, to be opened in the sidebar
 			Uses a separate 'board' objects for each format	

*/
 	
 var boardObserver = { 
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet();
 			//flavours.appendFlavour("text/html");
 			flavours.appendFlavour("text/x-moz-url");
 			flavours.appendFlavour("text/unicode");	 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{ //do nothing
 		},
 		
 		
 		onDrop: function (evt,dropdata,session)
 		{
 			if (dropdata.data!="")
 			{
 		   var dragSession=session;
 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
 		  
 			var elem=document.createElement("textbox"); 
 			evt.target.appendChild(elem);
 			
 			elem.setAttribute("multiline",true); 			
 			elem.setAttribute("value",dropdata.data);
 			elem.setAttribute("onfocus","select()"); //whoa :-) 			
 			}
 		},
 		
 	
 };
 
 
  var htmlObserver = { 
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet(); 	
 			flavours.appendFlavour("text/html"); 			 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{ //do nothing
 		},
 		
 		
 		onDrop: function (evt,dropdata,session)
 		{
 			if (dropdata.data!="")
 			{
 		   var dragSession=session;
 		   //alert(dropdata.data + "\n content type= "+ dropdata.flavour.contentType);
 		  
 			var elem=document.createElement("textbox"); 
 			evt.target.appendChild(elem);
 			
 			elem.setAttribute("multiline",true); 			
 			elem.setAttribute("value",dropdata.data);
 			elem.setAttribute("onfocus","select()"); //whoa :-) 			
 			}
 		},
 		
 	
 };
 
 /* **************************************************************** */
 
  var imgDNDObserver = {
  
       
 		getSupportedFlavours : function () 
 		{
 			var flavours = new FlavourSet();
 			
 			flavours.appendFlavour("image/png"); 			
 			flavours.appendFlavour("image/jpg");flavours.appendFlavour("image/jpeg");
 			flavours.appendFlavour("image/gif");
 			 			
 			return flavours;
 		},
 		
 		onDragOver: function (evt,flavour,session)
 		{
 		},
 		
 		
 		onDrop: function (evt,dropdata,session)
 		{  
 		    var type=dropdata.flavour.contentType;
 		   	if (type.search(/^image/) == -1) {alert("Data doesn't look like an image!");return;}
 		   	
 		   	//else
 		  try{
 			//if an image is already present, then that image becomes the target!	
 			var evtTarget=evt.target;
 			var tID=" "+evtTarget.getAttribute("id");
 			//climb up to the box
 			while(tID.search(/imgboard/) == -1 )
 			{
 			  evtTarget=evtTarget.parentNode;
 			  tID=" "+evtTarget.getAttribute("id");
 			
 			}
 			
 			var topBox=evtTarget; 			
 		   
 			var elem=(session.sourceNode).cloneNode(true);			
 			
 			topBox.appendChild(elem);
 			//needed
 			elem.setAttribute("width",session.sourceNode.width);
 			elem.setAttribute("height",session.sourceNode.height);
 			//fixes relative urls
 			elem.setAttribute("src",session.sourceNode.src);
 			//delete on doubleclick
 			//elem.setAttribute("ondblclick","imgDNDObserver.deleteThis(event)"); //whoa, but a gotcha! :-) 			
 			
 		 }catch(ex) {alert("Error: " + ex.message); /* or Die silently? */ }
 		},
 		
 		//remove an image on a specific event
 		deleteThis: function (ev)
 		{ 
 		  
 		   var img=ev.target;
 		   var tID=" "+img.getAttribute("id");
 		   if ((tID.search(/imgboard/) != -1 )) return;
 		   //else
 		   var board=img.parentNode;
 		   board.removeChild(img);
 		   ev.preventDefault();
 		},
 	
 };
